package doc

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

const (
	ConvertServer_Hello_FullMethodName = "/convert.ConvertServer/Hello"
)

// ConvertServerClient is the client API for ConvertServer service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ConvertServerClient interface {
	Hello(ctx context.Context, in *HelloRequest, opts ...grpc.CallOption) (*HelloResponse, error)
}

type convertServerClient struct {
	cc grpc.ClientConnInterface
}

func NewConvertServerClient(cc grpc.ClientConnInterface) ConvertServerClient {
	return &convertServerClient{cc}
}

func (c *convertServerClient) Hello(ctx context.Context, in *HelloRequest, opts ...grpc.CallOption) (*HelloResponse, error) {
	out := new(HelloResponse)
	err := c.cc.Invoke(ctx, ConvertServer_Hello_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ConvertServerServer is the server API for ConvertServer service.
// All implementations must embed UnimplementedConvertServerServer
// for forward compatibility
type ConvertServerServer interface {
	Hello(context.Context, *HelloRequest) (*HelloResponse, error)
	mustEmbedUnimplementedConvertServerServer()
}

// UnimplementedConvertServerServer must be embedded to have forward compatible implementations.
type UnimplementedConvertServerServer struct {
}

func (UnimplementedConvertServerServer) Hello(context.Context, *HelloRequest) (*HelloResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Hello not implemented")
}
func (UnimplementedConvertServerServer) mustEmbedUnimplementedConvertServerServer() {}

// UnsafeConvertServerServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ConvertServerServer will
// result in compilation errors.
type UnsafeConvertServerServer interface {
	mustEmbedUnimplementedConvertServerServer()
}

func RegisterConvertServerServer(s grpc.ServiceRegistrar, srv ConvertServerServer) {
	s.RegisterService(&ConvertServer_ServiceDesc, srv)
}

func _ConvertServer_Hello_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(HelloRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConvertServerServer).Hello(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ConvertServer_Hello_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConvertServerServer).Hello(ctx, req.(*HelloRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// ConvertServer_ServiceDesc is the grpc.ServiceDesc for ConvertServer service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ConvertServer_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "convert.ConvertServer",
	HandlerType: (*ConvertServerServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Hello",
			Handler:    _ConvertServer_Hello_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "hello.proto",
}
