package main

import (
	"fmt"
	"os"
	"os/exec"
)

func startScript(scriptName string) {
	cmd := exec.Command("nohup", "go", "run", scriptName, "&")
	err := cmd.Start()
	if err != nil {
		fmt.Printf("Error starting %s: %v\n", scriptName, err)
	}
}

func restartScript(scriptName string) {
	// Stop the script if it's already running
	stopScript(scriptName)
	// Start the script again
	startScript(scriptName)
}

func stopScript(scriptName string) {
	cmd := exec.Command("pkill", "-f", scriptName)
	err := cmd.Run()
	if err != nil {
		fmt.Printf("Error stopping %s: %v\n", scriptName, err)
	}
}

func main() {
	if len(os.Args) < 3 {
		fmt.Println("Usage: control_script <command> <script_name>")
		return
	}

	command := os.Args[1]
	scriptName := os.Args[2]

	switch command {
	case "start":
		startScript(scriptName)
	case "restart":
		restartScript(scriptName)
	case "stop":
		stopScript(scriptName)
	default:
		fmt.Println("Unknown command. Use 'start', 'restart', or 'stop'.")
	}
}
